const axios = require('axios');
const https = require('https');
const fs = require('fs');

const { spawn, exec } = require('child_process');
require('dotenv').config();

還原文字 = `\x1b[0m`;
紅色文字 = `\x1b[31m`;
綠色文字 = `\x1b[32m`;
黃色文字 = `\x1b[33m`;
藍色文字 = `\x1b[34m`;
紫色文字 = `\x1b[35m`;
青色文字 = `\x1b[36m`;
Twitch文字 = `\x1b[38;2;145;70;255m`;
Discord文字 = `\x1b[38;2;114;137;218m`;
正在實況文字 = `\x1b[38;2;44;255;51m`;
不在實況文字 = `\x1b[38;2;30;171;34m`;
自訂黃色文字 = `\x1b[38;2;255;255;0m`;
自訂時間文字 = `\x1b[38;2;255;200;200m`;
白底黑字文字 = `\x1b[38;2;0;0;0m\x1b[47m`;

config = loadConfig();
function loadConfig() {
	try {
		const data = fs.readFileSync('./config.json', 'utf8');
		return JSON.parse(data);
	} catch (error) {
		console.log(`${自訂時間文字}${目前時間()}${還原文字} 發生錯誤：${error.message}`);
		return null;
	}
}

async function checkStreamStatus(channelid) {
	try {
		return await axios.get(`https://api.twitch.tv/helix/streams?user_id=${channelid}`, {
			headers: {
				'Client-ID': 'gp762nuuoqcoxypju8c569th9wz7q5',
				'Authorization': `Bearer ${config.Twitch_Oauth}`,
			}
		});
	} catch (error) {
		config = loadConfig();
		console.log(`${自訂時間文字}${目前時間()}${還原文字} ${黃色文字}重試 API 請求`);
		await new Promise(resolve => setTimeout(resolve, 1000));
		return checkStreamStatus(channelid);
	}
}

let stream_check_true_false = {};
let now_on_stream = false;

runCheckStreams();
async function runCheckStreams() {
	if (now_on_stream) {
		await new Promise(resolve => setTimeout(resolve, 150));
		return;
	}
	console.log(`${白底黑字文字}　　　　　　　　　　　　　　　　　　　　開始檢測　　　　　　　　　　　　　　　　　　　　${還原文字}`);
	
	const promises = [];
	config = loadConfig();
	for (let [channelid, channelname] of Object.entries(config.Twitch_userid)) {
		const promise = checkStreamStatus(channelid)
			.then(response => CheckStreams(channelid, channelname, response))
			.catch(error => {
				stream_check_true_false[channelid] = false;
				console.error(`${自訂時間文字}${目前時間()}${還原文字} ${紅色文字}獲取直播狀態時發生錯誤${還原文字}：`, error);
			});
		promises.push(promise);
		await new Promise(resolve => setTimeout(resolve, 150));
	}

	const timeoutPromise = new Promise((resolve, reject) => {
		setTimeout(() => {
			reject(new Error("檢查超時"));
		}, 10000);
	});

	try {
		await Promise.race([
			Promise.all(promises),
			timeoutPromise
		]);
		console.log(`${白底黑字文字}　　　　　　　　　　　　　　　　　　　　結束檢測　　　　　　　　　　　　　　　　　　　　${還原文字}`);
		runCheckStreams();
	} catch (error) {
		console.error(`${紅色文字}檢查過程中發生錯誤或超時：${還原文字}`, error);
		runCheckStreams();
	}
}

async function CheckStreams(channelid, channelname, response) {
	try {
		if (now_on_stream) {
			return;
		}
		const streams = response.data.data;
		if (streams.length > 0) {
			if (!stream_check_true_false[channelid]) {
				console.log(`${自訂時間文字}${目前時間()}${還原文字} ${綠色文字}實況主 ${還原文字}${streams[0].user_name} ${綠色文字}正在實況中${還原文字} - ${綠色文字}開啟瀏覽器${還原文字}`);
				now_on_stream = true;
				if (config.Twitch_RestartBrowser_user.includes(channelname)) {
					if (config.Watch_Browser_local) {
						await closeWatch_Browser(channelid, channelname, streams[0].user_login);
					}
					if (config.Mod_Browser_local) {
						await closeMod_Browser(channelid, channelname, streams[0].user_login);
					}
				} else {
					if (config.Watch_Browser_local) {
						await openWatch_Browser(`https://www.twitch.tv/${streams[0].user_login}`, channelid);
					}
				}
				stream_check_true_false[channelid] = true;
			} else {
				console.log(`${自訂時間文字}${目前時間()}${還原文字} ${綠色文字}實況主 ${還原文字}${streams[0].user_name} ${綠色文字}正在實況中${還原文字}`);
				stream_check_true_false[channelid] = true;
			}
		} else {
			console.log(`${自訂時間文字}${目前時間()}${還原文字} ${紅色文字}實況主 ${還原文字}${channelname}${紅色文字} 不在直播${還原文字}`);
			stream_check_true_false[channelid] = false;
		}
	} catch (error) {
		stream_check_true_false[channelid] = false;
		console.error(`${自訂時間文字}${目前時間()}${還原文字} ${紅色文字}獲取直播狀態時發生錯誤${還原文字}：`, error);
	}
}

async function openWatch_Browser(Watch_Browser_url, channelid) {
	const Watch_Browser_browser = spawn(config.Watch_Browser_local, [Watch_Browser_url]);
	Watch_Browser_browser.on('error', (err) => {
		console.error(`${自訂時間文字}${目前時間()}${還原文字} ${紅色文字}無法啟動Watch_Browser瀏覽器：${還原文字}`, err);
		stream_check_true_false[channelid] = false;
	});
	await new Promise(resolve => setTimeout(resolve, 3500));
	now_on_stream = false;
}

async function openMod_Browser(Mod_Browser_url, channelid) {
	const Mod_Browser_browser = spawn(config.Mod_Browser_local, [Mod_Browser_url]);
	Mod_Browser_browser.on('error', (err) => {
		console.error(`${自訂時間文字}${目前時間()}${還原文字} ${紅色文字}無法啟動Mod_Browser瀏覽器：${還原文字}`, err);
		stream_check_true_false[channelid] = false;
	});
}

async function closeWatch_Browser(channelid, channelname, channellogin) {
	for (let [cid, cname] of Object.entries(config.Twitch_userid)) {
		stream_check_true_false[cid] = false;
	}

	const fileName = config.Watch_Browser_local.split('\\').pop();
	const taskkill_Watch_Browser = spawn('taskkill', ['/IM', fileName, '/F']);

	taskkill_Watch_Browser.on('error', (err) => {
		if (err.code === 'ENOENT') {
			console.error(`${自訂時間文字}${目前時間()}${還原文字} ${紅色文字}找不到 taskkill 工具，無法關閉 Watch_Browser。${還原文字}`);
		} else {
			console.error(`${自訂時間文字}${目前時間()}${還原文字} ${紅色文字}關閉${還原文字} Watch_Browser 時發生錯誤：`, err);
		}
	});

	taskkill_Watch_Browser.on('exit', async (code) => {
		if (config.Twitch_RestartBrowser_user.includes(channelname)) {
			stream_check_true_false[channelid] = true;
			if (config.Watch_Browser_local) {
				await openWatch_Browser(`https://www.twitch.tv/${channellogin}`, channelid);
			}
			if (config.Mod_Browser_local) {
				await openMod_Browser(`https://www.twitch.tv/embed/${channellogin}/chat?darkpopout&parent=gjptag.jsvtb.cc`, channelid);
			}
			await new Promise(resolve => setTimeout(resolve, 10000));
		}
		if (code === 0) {
			console.log(`${自訂時間文字}${目前時間()}${還原文字} ${紅色文字}成功關閉${還原文字} Watch_Browser`);
		} else {
			console.error(`${自訂時間文字}${目前時間()}${還原文字} ${紅色文字}關閉${還原文字} Watch_Browser 過程中出錯，退出碼：${code}`);
		}
		runCheckStreams();
	});
}

async function closeMod_Browser(channelid, channelname, channellogin) {
	const fileName = config.Mod_Browser_local.split('\\').pop();
	const taskkill_Mod_Browser = spawn('taskkill', ['/IM', fileName, '/F']);

	taskkill_Mod_Browser.on('error', (err) => {
		if (err.code === 'ENOENT') {
			console.error(`${自訂時間文字}${目前時間()}${還原文字} ${紅色文字}找不到 taskkill 工具，無法關閉 Mod_Browser。${還原文字}`);
		} else {
			console.error(`${自訂時間文字}${目前時間()}${還原文字} ${紅色文字}關閉${還原文字} Mod_Browser 時發生錯誤：`, err);
		}
	});

	taskkill_Mod_Browser.on('exit', async (code) => {
		if (code === 0) {
			console.log(`${自訂時間文字}${目前時間()}${還原文字} ${紅色文字}成功關閉${還原文字} Mod_Browser`);
		} else {
			console.error(`${自訂時間文字}${目前時間()}${還原文字} ${紅色文字}關閉${還原文字} Mod_Browser 過程中出錯，退出碼：${code}`);
		}
	});
}

function 目前時間() {
	const nowtime_log = new Date();

	const nowtime_Year_log = nowtime_log.getFullYear();
	const nowtime_Month_log = (nowtime_log.getMonth() + 1).toString().padStart(2, '0');
	const nowtime_Date_log = nowtime_log.getDate().toString().padStart(2, '0');
	const nowtime_AllDate_log = `${nowtime_Year_log}\/${nowtime_Month_log}\/${nowtime_Date_log}`;

	const nowtime_hours_log = (nowtime_log.getHours() % 12).toString().padStart(2, '0');
	const nowtime_minutes_log = nowtime_log.getMinutes().toString().padStart(2, '0');
	const nowtime_seconds_log = nowtime_log.getSeconds().toString().padStart(2, '0');
	const nowtime_milliseconds_log = nowtime_log.getMilliseconds().toString().padEnd(3, '0');
	const nowtime_meridiem_log = nowtime_log.getHours() >= 12 ? 'PM' : 'AM';
	const nowtime_AllTime_log = `${nowtime_hours_log}:${nowtime_minutes_log}:${nowtime_seconds_log}.${nowtime_milliseconds_log} ${nowtime_meridiem_log}`;

	const nowtime_all_log = `${nowtime_AllDate_log} ${nowtime_AllTime_log}`;
	return nowtime_all_log;
}